// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/SIO4%20and%20SIO8/SIO4_Linux_2.x.x_GSC_DN/driver/mp_sp508.c $
// $Rev: 23033 $
// $Date: 2013-08-27 15:08:43 -0500 (Tue, 27 Aug 2013) $

#include "main.h"



//*****************************************************************************
int mp_sp508_select(chan_data_t* chan, s32* prot)
{
	static const s32	list[16]	=
	{
		SIO4_XCVR_PROTOCOL_RS422_RS485,		// 0
		SIO4_XCVR_PROTOCOL_RS423,			// 1
		SIO4_XCVR_PROTOCOL_RS232,			// 2
		SIO4_XCVR_PROTOCOL_UNKNOWN,			// 3
		SIO4_XCVR_PROTOCOL_RS530,			// 4
		SIO4_XCVR_PROTOCOL_RS530A,			// 5
		SIO4_XCVR_PROTOCOL_V35,				// 6
		SIO4_XCVR_PROTOCOL_V35A,			// 7
		SIO4_XCVR_PROTOCOL_RS422_RS423_1,	// 8
		SIO4_XCVR_PROTOCOL_RS422_RS423_2,	// 9
		SIO4_XCVR_PROTOCOL_UNKNOWN,			// 10
		SIO4_XCVR_PROTOCOL_UNKNOWN,			// 11
		SIO4_XCVR_PROTOCOL_UNKNOWN,			// 12
		SIO4_XCVR_PROTOCOL_UNKNOWN,			// 13
		SIO4_XCVR_PROTOCOL_UNKNOWN,			// 14
		SIO4_XCVR_PROTOCOL_DISABLE			// 15
	};

	int	i;
	u32	mask;
	int	ret;
	u32	v;

	switch (prot[0])
	{
		default:

			ret	= -EINVAL;
			break;

		case -1:

			v		= os_reg_read_mem_u32(chan->dev, chan->vaddr.gsc_psrcr_32);
			v		= GSC_FIELD_DECODE(v, 27, 24);
			prot[0]	= list[v];
			ret		= 0;
			break;

		case SIO4_XCVR_PROTOCOL_DISABLE:
		case SIO4_XCVR_PROTOCOL_RS232:
		case SIO4_XCVR_PROTOCOL_RS422_RS423_1:
		case SIO4_XCVR_PROTOCOL_RS422_RS423_2:
		case SIO4_XCVR_PROTOCOL_RS422_RS485:
		case SIO4_XCVR_PROTOCOL_RS423:
		case SIO4_XCVR_PROTOCOL_RS530:
		case SIO4_XCVR_PROTOCOL_RS530A:
		case SIO4_XCVR_PROTOCOL_V35:
		case SIO4_XCVR_PROTOCOL_V35A:

			ret	= -EINVAL;

			for (i = 0; i <= 15; i++)
			{
				if (list[i] == prot[0])
				{
					v		= GSC_FIELD_ENCODE(i,	27, 24);
					mask	= GSC_FIELD_ENCODE(0xF,	27, 24);
					reg_mem32_mod(chan->vaddr.gsc_psrcr_32, v, mask);
					ret		= 0;
				}
			}

			break;
	}

	return(ret);
}


