// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/SIO4%20and%20SIO8/SIO4_Linux_2.x.x_GSC_DN/hdlc/lib/rx_adrs.c $
// $Rev: 23019 $
// $Date: 2013-08-27 14:49:19 -0500 (Tue, 27 Aug 2013) $

#include "main.h"



//*****************************************************************************
static int _show(s32 set)
{
	int	errs	= 0;

	gsc_label("USC Rx Address");

	if (set == -1)
	{
		printf("This service is not supported by this board.\n");
	}
	else if ((set < 0) || (set > 0xFF))
	{
		errs++;
		printf("Invalid value: %ld\n", (long) set);
	}
	else
	{
		gsc_label_long_comma(set);
		printf("\n");
	}

	return(errs);
}



//*****************************************************************************
void sio4_hdlc_t_rx_adrs(
	int					fd,
	s32*				arg,
	sio4_hdlc_action_t	action,
	const char**		err)
{
	#define		ERROR	  "hdlc->rx.adrs"
	int			errs	= 0;
	const char*	sts		= NULL;
	u32			tmp;

	switch (action)
	{
		default:

				sts		= ERROR;
				break;

		case SIO4_HDLC_ACTION_GET:

				errs	= sio4_reg_read(fd, SIO4_USC_RSR, &tmp);
				arg[0]	= (s32) (tmp & 0xFF);
				break;

		case SIO4_HDLC_ACTION_INIT:

				arg[0] = 0xFF;
				break;

		case SIO4_HDLC_ACTION_SET:

				errs	= sio4_reg_mod(fd, SIO4_USC_RSR, arg[0], 0xFF);
				break;

		case SIO4_HDLC_ACTION_SHOW:

				errs	= _show(arg[0]);
				break;

		case SIO4_HDLC_ACTION_VERIFY:

				if ((arg[0] < -1) || (arg[0] > 0xFF))
					errs	= 1;

				break;
	}

	if (errs)
		sts		= ERROR;

	if ((err) && (sts))
		err[0]	= sts;
}


