// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/SIO4%20and%20SIO8/SIO4_Linux_2.x.x_GSC_DN/hdlc/lib/usc_cfg_rxc_ctr0_brg1_dpll.c $
// $Rev: 26109 $
// $Date: 2014-05-17 15:56:56 -0500 (Sat, 17 May 2014) $

#include "main.h"



#if 0

// This code was nullified as the USC clocking configuration options were
// reduced. This was done so that the USC Tx Clock is never derived from the
// DPLL. This prevents any problems where the Tx is looped to the Rx at the
// cable interface.

//*****************************************************************************
void cfg_rxc_ctr0_brg1_dpll(sio4_hdlc_t* hdlc, s32 bit_rate)
{
	typedef struct
	{
		int		use;			//							yes, no
		s32		divide;			//							32, 16, 8, 4, 1
		s32		rate;			// hdlc->usc.ctr0.rate		32, 16, 8, 4, 1
		s32		clk_src;		// hdlc->usc.ctr0.clk_src	RxC, disable
	}  ctr0_t;

	//										use	divide	rate							clk_src
	static const ctr0_t	ctr0_32			= { 1,	32,		SIO4_HDLC_USC_CTR0_RATE_32X,	SIO4_HDLC_USC_CTR0_CLK_SRC_RXC_PIN	};
	static const ctr0_t	ctr0_16			= { 1,	16,		SIO4_HDLC_USC_CTR0_RATE_16X,	SIO4_HDLC_USC_CTR0_CLK_SRC_RXC_PIN	};
	static const ctr0_t	ctr0_8			= { 1,	8,		SIO4_HDLC_USC_CTR0_RATE_8X,		SIO4_HDLC_USC_CTR0_CLK_SRC_RXC_PIN	};
	static const ctr0_t	ctr0_4			= { 1,	4,		SIO4_HDLC_USC_CTR0_RATE_4X,		SIO4_HDLC_USC_CTR0_CLK_SRC_RXC_PIN	};
	static const ctr0_t	ctr0_dis		= { 0,	0,		SIO4_HDLC_USC_CTR0_RATE_32X,	SIO4_HDLC_USC_CTR0_CLK_SRC_DISABLE	};

	typedef struct
	{
		s32			use;		//							yes, no
		s32			enable;		// hdlc->usc.brg1.enable	yes, no
		s32			clk_src;	// hdlc->usc.brg1.clk_src	CTR0, RxC
	} brg1_t;

	//										use	enable							clk_src
	static const brg1_t	brg1_ctr0		= { 1,	SIO4_HDLC_USC_BRG1_ENABLE_YES,	SIO4_HDLC_USC_BRG1_CLK_SRC_CTR0		};
	static const brg1_t	brg1_rxc		= { 1,	SIO4_HDLC_USC_BRG1_ENABLE_YES,	SIO4_HDLC_USC_BRG1_CLK_SRC_RXC_PIN	};
	static const brg1_t	brg1_dis		= { 0,	SIO4_HDLC_USC_BRG1_ENABLE_NO,	SIO4_HDLC_USC_BRG1_CLK_SRC_CTR0		};

	typedef struct
	{
		s32			divide;		//							32, 16, 8
		s32			rate;		// hdlc->usc.dpll.rate		32, 16, 8
		s32			clk_src;	// hdlc->usc.dpll.clk_src	BRG1, RxC
	} dpll_t;

	//										divide	rate							clk_src
	static const dpll_t	dpll_32_brg1	= { 32,		SIO4_HDLC_USC_DPLL_RATE_32X,	SIO4_HDLC_USC_DPLL_CLK_SRC_BRG1		};
	static const dpll_t	dpll_16_brg1	= { 16,		SIO4_HDLC_USC_DPLL_RATE_16X,	SIO4_HDLC_USC_DPLL_CLK_SRC_BRG1		};
	static const dpll_t	dpll_08_brg1	= { 8,		SIO4_HDLC_USC_DPLL_RATE_8X,		SIO4_HDLC_USC_DPLL_CLK_SRC_BRG1		};
	static const dpll_t	dpll_32_rxc		= { 32,		SIO4_HDLC_USC_DPLL_RATE_32X,	SIO4_HDLC_USC_DPLL_CLK_SRC_RXC_PIN	};
	static const dpll_t	dpll_16_rxc		= { 16,		SIO4_HDLC_USC_DPLL_RATE_16X,	SIO4_HDLC_USC_DPLL_CLK_SRC_RXC_PIN	};
	static const dpll_t	dpll_08_rxc		= { 8,		SIO4_HDLC_USC_DPLL_RATE_8X,		SIO4_HDLC_USC_DPLL_CLK_SRC_RXC_PIN	};

	static const struct
	{
		const dpll_t*	dpll;
		const brg1_t*	brg1;
		const ctr0_t*	ctr0;
	} data[]	=
	{	// dpll				brg1		ctr0
		{ &dpll_08_rxc,		&brg1_dis,	&ctr0_dis	},
		{ &dpll_16_rxc,		&brg1_dis,	&ctr0_dis	},
		{ &dpll_32_rxc,		&brg1_dis,	&ctr0_dis	},

		{ &dpll_08_brg1,	&brg1_rxc,	&ctr0_dis	},
		{ &dpll_16_brg1,	&brg1_rxc,	&ctr0_dis	},
		{ &dpll_32_brg1,	&brg1_rxc,	&ctr0_dis	},

		{ &dpll_08_brg1,	&brg1_ctr0,	&ctr0_4 	},
		{ &dpll_08_brg1,	&brg1_ctr0,	&ctr0_8 	},
		{ &dpll_08_brg1,	&brg1_ctr0,	&ctr0_16	},
		{ &dpll_08_brg1,	&brg1_ctr0,	&ctr0_32	},

		{ &dpll_16_brg1,	&brg1_ctr0,	&ctr0_4		},
		{ &dpll_16_brg1,	&brg1_ctr0,	&ctr0_8		},
		{ &dpll_16_brg1,	&brg1_ctr0,	&ctr0_16	},
		{ &dpll_16_brg1,	&brg1_ctr0,	&ctr0_32	},

		{ &dpll_32_brg1,	&brg1_ctr0,	&ctr0_4		},
		{ &dpll_32_brg1,	&brg1_ctr0,	&ctr0_8		},
		{ &dpll_32_brg1,	&brg1_ctr0,	&ctr0_16	},
		{ &dpll_32_brg1,	&brg1_ctr0,	&ctr0_32	},
	};

	float	delta;
	float	delta_best	= 0;
	s32		divide;
	int		i;
	int		j;
	int		max;
	int		min;
	float	rate;
	s32		tc1;
	float	test;
	int		tested		= 0;

	for (i = 0; i < (int) ARRAY_ELEMENTS(data); i++)
	{
		rate	= (float) hdlc->osc.prog;
		rate	/= data[i].dpll->divide;

		if (data[i].ctr0->use)
			rate	/= data[i].ctr0->divide;

		if (data[i].brg1->use)
		{
			divide	= (s32) (rate / bit_rate);
			min		= divide - 1;
			max		= divide + 1;
		}
		else
		{
			min	= 1;
			max	= 1;
		}

		for (j = min; j <= max; j++)
		{
			if (data[i].brg1->use == 0)
				tc1	= 1;
			else if (j < 2)
				tc1	= 2;
			else if (j > 0x10000)
				tc1	= 0x10000;
			else
				tc1	= j;

			test	= rate / tc1;
			delta	= test - bit_rate;
			delta	= (delta < 0) ? -delta : delta;

			if (test > 10000000L)
				continue;

			if ((tested == 0) || (delta < delta_best))
			{
				tested					= 1;
				delta_best				= delta;

				hdlc->usc.brg1.clk_src	= data[i].brg1->clk_src;
				hdlc->usc.brg1.enable	= data[i].brg1->enable;
				hdlc->usc.brg1.divider	= tc1 - 1;

				hdlc->usc.ctr0.rate		= data[i].ctr0->rate;
				hdlc->usc.ctr0.clk_src	= data[i].ctr0->clk_src;

				hdlc->usc.dpll.rate		= data[i].dpll->rate;
				hdlc->usc.dpll.clk_src	= data[i].dpll->clk_src;

				hdlc->rx.bit_rate		= (s32) (test + 0.5);
			}
		} // j
	} // i
}
#endif


