// $URL: http://subversion:8080/svn/gsc/trunk/drivers/INtime/sio4/SIO4_INtime_2.x.x.x_DN/lib/main.c $
// $Rev: 26116 $
// $Date: 2014-05-18 14:05:58 -0500 (Sun, 18 May 2014) $

// INtime 4 library

#include "main.h"



//*****************************************************************************
int sio4_close(int fd)
{
	int	err_no;
	int	ret;

	err_no	= os_close(fd);
	ret		= err_no ? -1 : 0;
	SetLastRtError(err_no);
	return(ret);
}



//*****************************************************************************
int sio4_ioctl(int fd, int cmd, void* buf)
{
	int	err_no;
	int	ret;

	err_no	= os_ioctl(fd, cmd, buf);
	ret		= err_no ? -1 : 0;
	SetLastRtError(err_no);
	return(ret);
}



//*****************************************************************************
int sio4_open(int index)
{
	int			err_no;
	os_file_t*	fp	= NULL;
	int			ret;

	err_no	= os_open(index, SIO4_BASE_NAME, &fp);

	if (err_no)
	{
		SetLastRtError(err_no);
		ret	= -1;
	}
	else
	{
		SetLastRtError(0);
		ret	= (int) fp;
	}

	return(ret);
}



//*****************************************************************************
int sio4_read(int fd, void* dst, int bytes)
{
	int	err_no;
	int	got		= 0;
	int	ret;

	err_no	= os_read(fd, dst, bytes, &got);

	if (err_no)
		ret	= -1;
	else
		ret	= got;

	SetLastRtError(err_no);
	return(ret);
}



//*****************************************************************************
int sio4_write(int fd, const void* src, int bytes)
{
	int	err_no;
	int	ret;
	int	sent	= 0;

	err_no	= os_write(fd, src, bytes, &sent);

	if (err_no)
		ret	= -1;
	else
		ret	= sent;

	SetLastRtError(err_no);
	return(ret);
}


