// $URL: http://subversion:8080/svn/gsc/trunk/drivers/gsc_common/lib/intime/os_lib_main.h $
// $Rev: 26099 $
// $Date: 2014-05-16 10:51:54 -0500 (Fri, 16 May 2014) $

// INtime 4 library

#ifndef __OS_MAIN_H__
#define __OS_MAIN_H__

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "os_common.h"
#include "rt.h"



// #defines *******************************************************************

#define	VERSION_LIB_OS					"2"
// 2	Fixed memory leak problems.
//		Improved error condition reporting.
//		Simplified error reporting,
//		Made some services more modular.
// 1	Improved error handling.


// data types *****************************************************************

typedef struct
{
	RTHANDLE	sem;
} os_sem_t;

typedef struct
{
	void*		val_ptr;	// equals address of structure if valid
	os_sem_t	sem;		// control access to this structure
	RTHANDLE	dev_mbox;	// send messages here
} os_file_t;

typedef struct
{
	RTHANDLE	mbox;
} os_mbox_t;



// prototypes *****************************************************************

int		os_close(int fd);
int		os_ioctl(int fd, int cmd, void* buf);
int		os_open(int index, const char* base, os_file_t** fp);
int		os_read(int fd, void* dst, int bytes, int* got);
int		os_write(int fd, const void* src, int bytes, int* sent);

// These are for internal use only.
int		os_mem_handle_create(void* ptr, int bytes, u32* offset, RTHANDLE* handle);
void	os_mem_handle_destroy(RTHANDLE* mem);

int		os_mbox_alloc(os_mbox_t** mbox);
void	os_mbox_free(os_mbox_t** mbox);

int		os_msg_alloc(os_msg_t** msg);
void	os_msg_free(os_msg_t** msg);

int		os_sem_create(os_sem_t* sem);
void	os_sem_destroy(os_sem_t* sem);
int		os_sem_lock(os_sem_t* sem);
void	os_sem_unlock(os_sem_t* sem);



#endif
